package jasarus.di.spi;

import jasarus.di.api.NoSuchDependencyException;

/**
 * Dependency injection framework facade.
 */
public interface DependenciesRegistry {

    <T> T lookup(Class<T> type) throws NoSuchDependencyException;

    /**
     * Look up the container in order to find the dependency with of given type with given qualifier.
     *
     * @param type      Type of the requested dependency.
     * @param qualifier JSR-330 qualifier for the dependency.
     * @param <T>       Type of the requested dependency.
     * @return
     * @throws NoSuchDependencyException If no requested dependency
     */
    <T> T lookup(Class<T> type, String qualifier) throws NoSuchDependencyException;

    void injectInto(Object bean);

    void shutdown();

}
